<?php

namespace App\Service;


use App\Model\Depart;
use App\Model\Employee;
use App\Model\EmployeeDepartPermission;
use App\Model\EmployeeMenuPermission;
use App\Model\EmployeeTeamPermission;
use App\Model\Role;
use App\Model\SysMenu;
use App\Model\Team;
use Illuminate\Support\Facades\Hash;

/**
 * 人员相关
 * @package App\Models
 */
class EmployeeService extends Service
{

    public function employeeEdit($data){
        list($status,$msg) = $this->employeeRule($data);
        if(!$status) return [$status,$msg];
        $first = SysMenu::where('emp_id',$data['emp_id'])->where('del_time',0)->first();
        if(!empty($first))return [false,'工号已存在！'];

        $model = new Employee();
        $model = $model->where('id',$data['id'])->first();

        $model->id_card = $data['id_card']??'';
        $model->emp_id = $data['emp_id'] ;
        $model->mobile = $data['mobile'];
        $model->emp_name = $data['emp_name'];
        $model->state = 1;
//        $model->crt_id = $user->id;
//        $model->crt_time = time();
        $model->is_admin = $data['is_admin'];
        if($model->is_admin == 1){
            $model->account = $data['account'];
            if($data['password'] !== '********'){
                $model->password   = Hash::make($data['password']);
            }

        }
        $model->save();
        return [true,'保存成功！'];

    }

    public function employeeAdd($data,$user){


//        if($this->isEmpty($data,'title')) return [201,'名称不存在！'];
        list($status,$msg) = $this->employeeRule($data);
        if(!$status) return [$status,$msg];
//        $first = SysMenu::where('title',$data['title'])->where('del_time',0)->first();
        if(!empty($first))return [false,'名称已存在！'];

        $model = new Employee();

        $model->id_card = $data['id_card']??'';
        $model->emp_id = $data['emp_id'] ;
        $model->mobile = $data['mobile'];
        $model->emp_name = $data['emp_name'];
        $model->state = 1;
//        $model->crt_id = $user->id;
        $model->crt_id = 1;
//        $model->crt_time = time();
        $model->is_admin = $data['is_admin'];
        if($model->is_admin == 1){
            $model->account = $data['account'];
            $model->password   = Hash::make($data['password']);
        }
        $model->save();

        return [true,'保存成功！'];

    }

    public function employeeDel($data){
        if($this->isEmpty($data,'id')) return [false,'ID必须！'];

        Employee::where('id',$data['id'])->update([
            'del_time'=>time()
        ]);

        return [true,'删除成功'];
    }

    public function employeeList($data){
        $list = Employee::where('del_time',0)->select('id_card','emp_id','mobile','emp_name','crt_time','account','is_admin','upd_time','id')->orderBy('id','desc');

        $list = $this->limit($list,'',$data);

        return [200,$list];
    }

    public function employeeRule($data){
        if($this->isEmpty($data,'emp_id')) return [false,'工号不存在！'];
//        if($this->isEmpty($data,'icon')) return [201,'d不存在！'];
        if($this->isEmpty($data,'mobile')) return [false,'手机号不存在！'];
        if($this->isEmpty($data,'emp_name')) return [false,'姓名不存在！'];

        return [true,''];
    }


    public function roleEdit($data){
        list($status,$msg) = $this->roleRule($data);
        if(!$status) return [$status,$msg];
        $first = Role::where('title',$data['title'])->where('id','<>',$data['id'])->where('del_time',0)->first();
        if(!empty($first))return [false,'名称已存在！'];

        $model = new Role();
        $model = $model->where('id',$data['id'])->first();

        $model->title = $data['title'];
        $model->save();
        return [true,'保存成功！'];

    }

    public function roleAdd($data,$user){


//        if($this->isEmpty($data,'title')) return [201,'名称不存在！'];
        list($status,$msg) = $this->roleRule($data);
        if(!$status) return [$status,$msg];
        $first = SysMenu::where('title',$data['title'])->where('del_time',0)->first();
        if(!empty($first))return [false,'名称已存在！'];

        $model = new Role();

        $model->title = $data['title'] ;

        $model->save();

        return [true,'保存成功！'];

    }

    public function roleDel($data){
        if($this->isEmpty($data,'id')) return [false,'ID必须！'];

        Role::where('id',$data['id'])->update([
            'del_time'=>time()
        ]);

        return [true,'删除成功'];
    }

    public function roleList($data){
        $list = Role::where('del_time',0)->select('title','title','crt_time','id','upd_time')->orderBy('id','desc');

        $list = $this->limit($list,'',$data);

        return [200,$list];
    }

    public function roleRule($data){
        if($this->isEmpty($data,'title')) return [false,'名称不存在！'];

        return [true,''];
    }


    public function departEdit($data){
        list($status,$msg) = $this->departRule($data);
        if(!$status) return [$status,$msg];
        $first = Depart::where('title',$data['title'])->where('id','<>',$data['id'])->where('del_time',0)->first();
        if(!empty($first))return [false,'名称已存在！'];

        $model = new Depart();
        $model = $model->where('id',$data['id'])->first();

        $model->title = $data['title'];
        $model->code = $data['code']??'';
        $model->save();
        return [true,'保存成功！'];

    }

    public function departAdd($data,$user){


//        if($this->isEmpty($data,'title')) return [201,'名称不存在！'];
        list($status,$msg) = $this->departRule($data);
        if(!$status) return [$status,$msg];
        $first = Depart::where('title',$data['title'])->where('id','<>',$data['id'])->where('del_time',0)->first();
        if(!empty($first))return [false,'名称已存在！'];

        $model = new Depart();

        $model->title = $data['title'] ;
        $model->code = $data['code'] ?? '' ;

        $model->save();

        return [true,'保存成功！'];

    }

    public function departDel($data){
        if($this->isEmpty($data,'id')) return [false,'ID必须！'];

        Depart::where('id',$data['id'])->update([
            'del_time'=>time()
        ]);

        return [true,'删除成功'];
    }

    public function departList($data){
        $list = Depart::where('del_time',0)->select('title','crt_time','id','upd_time','code')->orderBy('id','desc');

        $list = $this->limit($list,'',$data);

        return [200,$list];
    }

    public function departRule($data){
        if($this->isEmpty($data,'title')) return [false,'名称不存在！'];

        return [true,''];
    }


    public function teamEdit($data){
        list($status,$msg) = $this->teamRule($data);
        if(!$status) return [$status,$msg];
        $first = Team::where('title',$data['title'])->where('id','<>',$data['id'])->where('del_time',0)->first();
        if(!empty($first))return [false,'名称已存在！'];

        $model = new Team();
        $model = $model->where('id',$data['id'])->first();

        $model->title = $data['title'];
        $model->code = $data['code'] ?? '';
        $model->save();
        return [true,'保存成功！'];

    }

    public function teamAdd($data,$user){


//        if($this->isEmpty($data,'title')) return [201,'名称不存在！'];
        list($status,$msg) = $this->teamRule($data);
        if(!$status) return [$status,$msg];
        $first = Team::where('title',$data['title'])->where('del_time',0)->first();
        if(!empty($first))return [false,'名称已存在！'];

        $model = new Team();

        $model->title = $data['title'] ;
        $model->code = $data['code'] ?? '' ;

        $model->save();

        return [true,'保存成功！'];

    }

    public function teamDel($data){
        if($this->isEmpty($data,'id')) return [false,'ID必须！'];

        Team::where('id',$data['id'])->update([
            'del_time'=>time()
        ]);

        return [true,'删除成功'];
    }

    public function teamList($data){
        $list = Team::where('del_time',0)->select('title','id','crt_time','upd_time','code')->orderBy('id','desc');

        $list = $this->limit($list,'',$data);

        return [200,$list];
    }

    public function teamRule($data){
        if($this->isEmpty($data,'title')) return [false,'名称不存在！'];

        return [true,''];
    }

    public function employeeRole($data){
        $role_ids = [];
        $employee_ids = [];
        foreach ($data as $v){
            if(isset($v['role_id'])){
                if(!in_array($v['role_id'],$role_ids)){
                    $role_ids[] = $v['role_id'];
                }
            }

            if(isset($v['employee_id'])){
                if(!in_array($v['employee_id'],$employee_ids)){
                    $employee_ids[] = $v['employee_id'];
                }
            }
        }

        EmployeeMenuPermission::wherein('role_id',$role_ids)->delete();
        EmployeeMenuPermission::wherein('employee_id',$employee_ids)->delete();


        EmployeeMenuPermission::insert($data);

        return [200,'保存成功!'];

    }

    public function employeeDepart($data){
        $type = $data['type'];

        if($type == 1){
            EmployeeDepartPermission::where('depart_id',$data['id'])->delete();
        }else{
            EmployeeDepartPermission::where('employee_id',$data['id'])->delete();
        }

        EmployeeDepartPermission::insert($data['insert']);

        return [200,'保存成功!'];
    }

    public function employeeTeam($data){
        $type = $data['type'];

        if($type == 1){
            EmployeeTeamPermission::where('team_id',$data['id'])->delete();
        }else{
            EmployeeTeamPermission::where('employee_id',$data['id'])->delete();
        }

        EmployeeTeamPermission::insert($data['insert']);

        return [200,'保存成功!'];
    }


}
